!***********************************************************************
!*****************************  KEK  High Energy Accelerator Research  *
!*****************************  Organization                           *
!***** u c s u c c e e d *****                                         *
!*****************************     EGS5.0 USER CODE - 30 Sep 2014/1600 *
!***********************************************************************
! EGS5 user's code to demonstrate how to use random number suceedingly *
! Programmer: Y.Namito and H.Hirayama (KEK)                            *
!***********************************************************************

      implicit none

      include 'include/randomm.f'

      real*8 r1, rnnow
      real etime, tt,tt0,tt1,cputime,tarray(2)
      integer i,mode

      mode=0
!          0: Default
!          1: write kount and mkount
!          2: Read kount and mkount from file
!          3: write isdext(i),i=1,25 to fort.56
!          4: Read isdext(i),i=1,25 from file

!          Followings output the identical random number.
!          - mode 0, 
!          - succeeding run of mode 1 and 2, 
!          - succeeding run of mode 3 and 4.

!     ==============
      call block_set
!     ==============

!     --------------------------------------------------------
!     Random number seeds.  Must be defined before call hatch
!     or defaults will be used.  inseed (1- 2^31)
!     --------------------------------------------------------
      luxlev = 1
      inseed=1

       if(mode.eq.2) then
         open(58,file='random58.txt',status='OLD')
!        read(58,'(5x,2i12)') kount,mkount
         read(58,*) kount,mkount
       end if

       if(mode.eq.4) then
         open(57,file='random56.txt',status='OLD')
!        read(57,'(5x,5i12)') (isdext(i),i=1,25)
         read(57,*) (isdext(i),i=1,25)
       end if

      tt=etime(tarray)
      tt0=tarray(1)
      call rluxinit
      tt=etime(tarray)
      tt1=tarray(1)
      cputime=tt1-tt0
      write(6,'(a,1pe12.5)')' cputime for rluxinit=',cputime

      do i=1,50
        call randomset(r1)
        write(6,'(a,i10,a,e12.5)')' i=',i,' r1=',r1
      end do

      if(mode.eq.0) then
      do i=51,100
        call randomset(r1)
        write(6,'(a,i10,a,e12.5)')' i=',i,' r1=',r1
      end do
      stop
      end if

      if(mode.eq.1) then
        open(58,file='random58.txt')
        write( 6,'(5x,2i12)') kount,mkount
        write(58,'(5x,2i12)') kount,mkount
       stop
       end if

      if(mode.eq.3) then
        open(56,file='random56.txt')
        call rluxout
        write( 6,'(5x,5i12)') isdext
        write(56,'(5x,5i12)') isdext
      stop
      end if

      stop
      end

      subroutine ausgab(i)
      integer i
      return
      end
      subroutine howfar
      return
      end
